﻿var earth = null;
var IP = '192.168.1.228';//数据服务所在主机IP地址
var projectId = 'd2cdce98-880c-4e54-9e21-95b2d4a220b1';//徐州工程ID号，暂用
var SYSTEMPARAMS = {};
SYSTEMPARAMS.project = projectId;
var htmlBalloons = null;//气泡小窗体
var excuteType = 27;//服务成功标示：27标示服务成功

//双击定位时，气泡显示详情信息
function showHtmlBalloon(vecCenterX, vecCenterY, vecCenterZ, htmlStr) {
    if (htmlBalloons) {
        htmlBalloons.DestroyObject();
        htmlBalloons = null;
    }
    var guid = earth.Factory.CreateGuid();
    htmlBalloons = earth.Factory.CreateHtmlBalloon(guid, "balloon");
    htmlBalloons.SetSphericalLocation(vecCenterX, vecCenterY, vecCenterZ);
    htmlBalloons.SetRectSize(280, 340);
    var color = parseInt("0xffffff00");
    htmlBalloons.SetTailColor(color);
    htmlBalloons.SetIsAddCloseButton(true);
    htmlBalloons.SetIsAddMargin(true);
    htmlBalloons.SetIsAddBackgroundImage(true);
    htmlBalloons.SetIsTransparence(true);
    htmlBalloons.SetBackgroundAlpha(0xcc);
    htmlBalloons.ShowHtml(htmlStr);
    earth.Event.OnHtmlBalloonFinished = function() {
        if (htmlBalloons != null) {
            htmlBalloons.DestroyObject();
            htmlBalloons = null;
        }
        earth.Event.OnHtmlBalloonFinished = function() {};
    }
};

//清除气泡
function clearHtmlBalloons() {
    if (htmlBalloons != null) {
        htmlBalloons.DestroyObject();
        htmlBalloons = null;
    }
};

/*--------------------------字段映射 Start------------------------------------------*/
/**
 * 根据标准字段名称返回显示字段名称（不区分大小写）
 * @param  {[type]} standardName     标准字段名称
 * @param  {[type]} pipeType         管线类型 1 -- 管线 0 -- 管点
 * @param  {[type]} returnFiledName  true返回FiledName false返回CaptionName
 * @return {[type]}                  显示名称
 */
function getName(standardName, pipeType, returnFiledName) {
    if (standardName === "" || standardName === undefined) {
        return;
    }
    if (pipeType === "" || pipeType === undefined) {
        return;
    }
    var configXML = SYSTEMPARAMS.pipeFieldMap;//管线字段映射XML（已从服务器读取获得）
    if (configXML == null) {
        return;
    }
    var lineData;
    if (pipeType === 1 || pipeType === "1") {
        lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    } else if (pipeType === 0 || pipeType === "0") {
        lineData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    }
    //循环查找每个节点，标准名与fieldName相同的就是想要的结果
    if (lineData && lineData.childNodes.length) {
        for (var i = lineData.childNodes.length - 1; i >= 0; i--) {
            var item = lineData.childNodes[i];
            if (item.getAttribute("StandardName").toUpperCase() == standardName.toUpperCase()) {
                if (returnFiledName) {
                    return item.getAttribute("FieldName").toUpperCase();
                } else {
                    return item.getAttribute("CaptionName");
                }
            }
        };
    }
};

/**
 * 根据标准字段名称返回显示字段名称（区分大小写）
 * @param  {[type]} standardName     标准字段名称
 * @param  {[type]} pipeType         管线类型 1 -- 管线 0 -- 管点
 * @param  {[type]} returnFiledName  true返回FiledName false返回CaptionName
 * @return {[type]}                  显示名称
 */
function getNameNoIgnoreCase(standardName, pipeType, returnFiledName) {
    if (standardName === "" || standardName === undefined) {
        return;
    }
    if (pipeType === "" || pipeType === undefined) {
        return;
    }
    var configXML = SYSTEMPARAMS.pipeFieldMap;//管线字段映射XML（已从服务器读取获得）
    var lineData;
    if (pipeType === 1 || pipeType === "1") {
        lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    } else if (pipeType === 0 || pipeType === "0") {
        lineData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    }
    //循环查找每个节点，标准名与fieldName相同的就是想要的结果
    if (lineData && lineData.childNodes.length) {
        for (var i = lineData.childNodes.length - 1; i >= 0; i--) {
            var item = lineData.childNodes[i];
            if (item.getAttribute("StandardName") == standardName) {
                if (returnFiledName) {
                    return item.getAttribute("FieldName");
                } else {
                    return item.getAttribute("CaptionName");
                }
            }
        };
    }
};

/**
 * 根据数据库字段名称返回标准名称
 * @param  {[type]} fieldName     数据库字段名称
 * @param  {[type]} pipeType         管线类型 1 -- 管线 0 -- 管点
 * @param  {[type]} returnStandardName  true返回StandardName false返回CaptionName
 * @return {[type]}                  显示名称
 */
function getStandardName(fieldName, pipeType, returnStandardName) {
    if (fieldName === "" || fieldName === undefined) {
        return;
    }
    if (pipeType === "" || pipeType === undefined) {
        return;
    }
    var configXML = SYSTEMPARAMS.pipeFieldMap;
    var lineData;
    if (pipeType === 1 || pipeType === "1") {
        lineData = configXML.getElementsByTagName("LineFieldInfo")[0] ? configXML.getElementsByTagName("LineFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    } else if (pipeType === 0 || pipeType === "0") {
        lineData = configXML.getElementsByTagName("PointFieldInfo")[0] ? configXML.getElementsByTagName("PointFieldInfo")[0].getElementsByTagName("SystemFieldList")[0] : null;
    }
    //循环查找每个节点，标准名与fieldName相同的就是想要的结果
    if (lineData && lineData.childNodes.length) {
        for (var i = lineData.childNodes.length - 1; i >= 0; i--) {
            var item = lineData.childNodes[i];
            if (item.getAttribute("FieldName").toUpperCase() == fieldName.toUpperCase()) {
                if (returnStandardName) {
                    return item.getAttribute("StandardName").toUpperCase();
                } else {
                    return item.getAttribute("CaptionName");
                }
            }
        };
    }
};

/*--------------------------会使用字段映射 End------------------------------------------*/


(function(ns) {
    //简单通过js修改css来自适应屏幕尺寸布局
    function _resize() {
        var downHeight = parseInt($('body').css('height')) + 'px';
        $('.panel-left').css('height', downHeight).css('top', '0px');
        $('.panel-right, #earthContainer').css('height', downHeight).css('top', '40px');
        var rightWidth = parseInt($('body').css('width')) - parseInt($('.panel-left').css('width')) + 'px';
        $('.panel-right, #earthContainer').css('width', rightWidth).css('left', $('.panel-left').css('width'));
        $('.panel-top').css('height', downHeight).css('height', '50px').css('top', '0px').css('width', rightWidth).css('left', $('.panel-left').css('width'));

        var leftContentHeight = parseInt($('body').css('height')) - parseInt($("#con_tab_nav").css('height')) - 40 + 'px';
        $('.tab-content').css('height', leftContentHeight);
    }

    //三维球加载数据
    function _loadEarth() {
        //在加载数据行为之前，对加载数据完成后的事件进行绑定
        seearth.Event.OnDocumentChanged = function(type, guid) {
            //因为这个一般只用执行一次，所以当绑定的事件触发后清除绑定
            seearth.Event.OnDocumentChanged = function() {};
            //修改当前视图的范围已经摄像机视角等，这里是为了演示方便写死进去的，可根据自己数据进行修改，参照api文档
            seearth.GlobeObserver.GotoLookat(117.17908617330566, 34.25850874093018, 32.19071602597978,
                0, 89.00038454023497, 0, 2421.534859522716);
            //当数据加载完成后，可以初始化图层树列表
            _initializeLayerTree();
            _initialConfig();
        };
        seearth.Load('http://'+IP, 0);
        earth = seearth;
    }

    //将三维球的activex代码注入到html dom中
    function _initializeEarth() {
        $('#earthContainer').empty().html('<object id="seearth" ' +
            'classid="clsid:EA3EA17C-5724-4104-94D8-4EECBD352964" ' +
            'data="data:application/x-oleobject;base64,Xy0TLBTXH0q8GKFyFzl3vgAIAADYEwAA2BMAAA==" ' +
            'width="100%" height="100%"></object>');
        //当object对象创建完毕，会触发下面绑定的事件
        seearth.Event.OnCreateEarth = function() {
            seearth.Event.OnCreateEarth = function() {};
            //开始加载数据
            _loadEarth();
        };
    }

    //初始化图层树列表
    //我们使用了第三方js插件ztree
    function _initializeLayerTree() {
        //初始化相关的管理对象实例，这个在加入lib/layerManager.js后会附加在STAMP全局变量中
        var seLayerManager = new STAMP.SeLayerManager({
            earth: seearth  //需要三维球实例
        });
        //获取图层树形结构
        var layerData = seLayerManager.getLayerTreeData();
        //ztree的设置
        var treeSetting = {
            showLine: true,
            checkable: true,
            treeId: 'c_mainPanel',
            check: {
                enable: true
            },
            callback: {
                //双击树节点，进行定位
                onDblClick: function(event, treeId, treeNode) {
                    seLayerManager.zoomToLayerByGuid(treeNode.id);
                },
                //勾选与否，打开关闭图层
                onCheck: function(event, treeId, treeNode) {
                    if (treeNode.checked) {
                        seLayerManager.showLayer(treeNode.id);
                    } else {
                        seLayerManager.hideLayer(treeNode.id);
                    }
                }
            },
            view: {
                dblClickExpand: false
            }
        };
        $.fn.zTree.init($('#c_mainPanel'), treeSetting, layerData);
    }

    //读取服务器的配置文件，获取字段映射表、空间参考数据等
    function _initialConfig(){
        //服务端属性配置开始！
        var layer = earth.LayerManager.GetLayerByGUID(projectId);
        var projectSetting = layer.ProjectSetting;//由后台管理系统配置得到的

        var fieldMap = projectSetting.FieldMapFile; //字段映射配置文件
        var filedPath = "";
        if (fieldMap.indexOf("http") >= 0) {
            filedPath = fieldMap;
        } else {
            filedPath = "http://" + fieldMap.substr(2).replace("/", "/sde?/") + "_sde";
        }
        //管线字段映射
        earth.Event.OnEditDatabaseFinished = function(pRes, pFeature) {
            if (pRes.ExcuteType == excuteType) {
                SYSTEMPARAMS.pipeFieldMap = loadXMLStr(pRes.AttributeName); //初始化编码映射文件对象
            }
        }
        earth.DatabaseManager.GetXml(filedPath);
    }

    //打开新面板
    function _openPanel(title, bShowClose){
        $('#leftContainer').find('#con_tab_nav li').removeAttr('class');//去掉其他tab标签的active状态
        $('#leftContainer').find('#con_tab_content .panel_Content').hide();//隐藏其他面板

        var panelId = '';
        if(bShowClose){//如果是功能面板（otherPanel），需要先移除其他的功能面板div，然后再添加新的面板div
            panelId = 'otherPanel';
            $('#leftContainer').find("#con_tab_nav li[flag='" + panelId + "']").remove();
            $('#leftContainer').find("#con_tab_content #" + panelId).remove();

            var stab = "<div id='" + panelId + "' class='panel_Content'></div>";
            var sli = "<li flag='" + panelId + "' class='active'><a href='#" + panelId + "' data-toggle='tab'>" +
                title + "&nbsp;" + "<span id='s_" + panelId + "' class='close_Panel'>x</span>" + "</a></li>";

            $('#leftContainer').find('#con_tab_content').append(stab);
            $('#leftContainer').find('#con_tab_nav').append(sli);

            $('#s_' + panelId).click(function(event) {
                var clickID = $(this).parent().parent().attr('flag');
                $(this).parent().parent().remove();
                $('#leftContainer').find('#con_tab_nav li').attr('class', 'active');

                $('#leftContainer').find('#con_tab_content #' + clickID).remove();
                $('#leftContainer').find('#con_tab_content').find("#mainPanel").show();
            });
        }else{//如果是图层面板（mainPanel），即页面初始化加载，需要额外添加图层树节点div
            panelId = 'mainPanel';
            var stab = "<div id='" + panelId + "' class='panel_Content' style='background-color:rgb(255, 255, 255)'></div>";
            var sli = "<li flag='" + panelId + "' class='active'><a href='#" + panelId + "' data-toggle='tab'>" +
                title + "&nbsp;" + "</a></li>";
            var sLayerTree = "<div id='c_" + panelId + "' class='viewContainer ztree' ></div>";

            $('#leftContainer').find('#con_tab_content').append(stab);
            $('#leftContainer').find('#con_tab_nav').append(sli);
            $('#leftContainer').find('#con_tab_content').find('#' + panelId).html(sLayerTree);
        }

        $('#leftContainer').find('#con_tab_content .panel_Content').find('#' + panelId).show();

        //tab标题点击事件，两个面板之间进行切换，分别显示他们的面板div
        $('#leftContainer').find("#con_tab_nav li[flag='" + panelId + "']").click(function(event) {
            $('#leftContainer').find('#con_tab_content .panel_Content').hide();//隐藏其他面板
            var clickID = $(this).attr("flag");
            $("#" + clickID).show();
        });
        
    }
    
    function _complexQuery(){
        _openPanel("复合查询", true);
        var iframeHtml = "<iframe src='view/complexQuery.html' width='100%' height='100%'></iframe>";
        $("#otherPanel").append(iframeHtml);
    }

    //domready
    $(function() {
        //禁用浏览器右键菜单
        $(document).bind("contextmenu", function(e) {
            return false;
        });
        //初次调整布局
        _resize();
        _openPanel("图层", false);
        _initializeEarth();

        //以下为绑定几个demo功能按钮事件
        $('#transbtn').click(function() {
            var transvalue = parseInt($('#transvalue').val());
            if (transvalue > 100) {
                transvalue = 100;
            } else if (transvalue < 0) {
                transvalue = 0;
            }
            // $('#transvalue').val(100);
            seearth.Environment.TerrainTransparency = transvalue * 2.55;
        });

        $('#complexQuery').click(function(event) {
            //复合查询
            _complexQuery();
        });

        //窗口变化事件
        window.onresize = _resize;
    })
}).call(this, window);
