/**
 * 文件名：query.js
 * 修改人: zhangd
 * 日期：2014-11-06
 * 备注：查询并导出功能
 */
var QueryObject = {
    paramQueryALL: function(pFeat, guid, filter, queryType, queryTableType, compoundCondition, total, standardName) {
        var layer = earth.LayerManager.GetLayerByGUID(guid);
        var subLayer = null;
        for (var i = 0, len = layer.GetChildCount(); i < len; i++) {
            subLayer = layer.GetChildAt(i);
            if (subLayer.LayerType == "Container") { // 使用具体的_container图层
                break;
            }
        }
        if (subLayer == null) {
            return;
        }
        var param = subLayer.QueryParameter;
        if (!param) {
            return;
        }
        param.ClearRanges();
        param.ClearCompoundCondition();
        param.ClearSpatialFilter();
        if (filter != null) {
            param.Filter = filter;
        } else {
            param.Filter = "";
        }
        if (pFeat != null) {
            param.SetSpatialFilter(pFeat);
        }
        if (queryTableType != null) {
            param.QueryTableType = queryTableType; // 0：SE_Table_Point，1：SE_Table_Line
        }
        if (compoundCondition != null) {
            var cc = compoundCondition.split(",");
            param.SetCompoundCondition(cc[0], cc[1], parseFloat(cc[2]).toFixed(3));
        }
        param.QueryType = queryType; // SE_AttributeData
        param.PageRecordCount = total || 2000;
        var result = subLayer.SearchFromGISServer();
        if (result !== null) {
            this.parseResult(result.GotoPage(0), layer, standardName);
        }
        return result;
    },
    parseResult: function(result, layer, standardName) {
        if (result == null || result == "error") {
            return;
        }

        var json = $.xml2json(result);
        var type = json.Result.geometry;
        var displayType = "管线";
        type = type === "point" ? "point" : "line";
        var template = '<tr>';
        if (standardName && standardName.length > 0) {
            for (var i = 0; i < standardName.length; i++) {
                template += '<td>$' + standardName[i] + '</td>';
            }
        }
        template += '</tr>';
        var records = json.Result.Record;
        if (json.Result.num <= 0) {
            return;
        } else if (json.Result.num == 1) {
            //只有一个记录
            if (type == "point") {
                var us_key_point = parent.getName("US_KEY", 0, true);
                var pointType = "管点";
                var usType = parent.getName("US_PT_TYPE", 0, true);
                var usAttach = parent.getName("US_ATTACHMENT", 0, true);
                var usWell = parent.getName("US_WELL", 0, true);
                if (records[usType]) {
                    typeText = records[usType];
                } else if (records[usAttach]) {
                    typeText = records[usAttach];
                } else if (records[usWell]) {
                    typeText = records[usWell];
                } else {
                    typeText = pointType;
                }
                $("#importResult>tbody").append(template.replace("$INDEX", records[us_key_point])
                    .replace("$DISPLAYTYPE", typeText)
                    .replace("$US_KEY", records[parent.getName("US_KEY", 0, true)]) //编号
                    .replace("$LAYER", layer.Name));
            } else {
                var us_key_line = parent.getName("US_KEY", 1, true);
                $("#importResult>tbody").append(template.replace("$INDEX", records[us_key_line])
                    .replace("$DISPLAYTYPE", displayType)
                    .replace("$US_KEY", us_key_line) //编号
                    .replace("$US_SIZE", records[parent.getName("US_SIZE", 1, true)]) //管径
                    .replace("$US_PMATER", records[parent.getName("US_PMATER", 1, true)]) //材质
                    .replace("$US_LTTYPE", records[parent.getName("US_LTTYPE", 1, true)]) //埋设方式
                    .replace("$US_STATUS", records[parent.getName("US_STATUS", 1, true)]) //废弃==状态
                    .replace("$LAYER", layer.Name));
            }
        } else {
            //多条记录
            for (var i = 0; i < records.length; i++) {
                if (type == "point") {
                    var pointType = "管点";
                    var us_key_point = parent.getName("US_KEY", 0, true);
                    var usType = parent.getName("US_PT_TYPE", 0, true);
                    var usAttach = parent.getName("US_ATTACHMENT", 0, true);
                    var usWell = parent.getName("US_WELL", 0, true);
                    if (records[i][usType]) {
                        pointType = records[i][usType];
                    } else if (records[i][usAttach]) {
                        pointType = records[i][usAttach];
                    } else if (records[i][usWell]) {
                        pointType = records[i][usWell];
                    }
                    $("#importResult>tbody").append(template.replace("$INDEX", records[i][us_key_point])
                        .replace("$DISPLAYTYPE", pointType) //类型
                        .replace("$US_KEY", records[i][parent.getName("US_KEY", 0, true)]) //编号
                        //.replace("$US_PMATER",records[i][parent.getName("US_PMATER",0,true)])
                        .replace("$LAYER", layer.Name));
                } else {
                    var us_key_line = parent.getName("US_KEY", 1, true);
                    $("#importResult>tbody").append(template.replace("$INDEX", records[i][us_key_line])
                        .replace("$DISPLAYTYPE", displayType) //类型
                        .replace("$US_KEY", us_key_line) //编号
                        .replace("$US_SIZE", records[i][parent.getName("US_SIZE", 1, true)]) //管径
                        .replace("$US_PMATER", records[i][parent.getName("US_PMATER", 1, true)]) //材质
                        .replace("$US_LTTYPE", records[i][parent.getName("US_LTTYPE", 1, true)]) //埋设方式
                        .replace("$US_STATUS", records[i][parent.getName("US_STATUS", 1, true)]) //废弃==状态
                        .replace("$LAYER", layer.Name));
                }
            }
        }
    }
};